PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PSemaphore Class Reference

This class defines a thread synchronisation object. More...

`#include <semaphor.h>`

Inheritance diagram for PSemaphore:
[legend]
Collaboration diagram for PSemaphore:
[legend]

## Public Member Functions
unsigned | GetInitial () const
unsigned | GetMaxCount () const
Construction
| PSemaphore (unsigned initial, unsigned maximum)
| Create a new semaphore with maximum count and initial value specified. More...
| PSemaphore (const PSemaphore &)
| Create a new semaphore with the same initial and maximum values as the original. More...
| ~PSemaphore ()
| Destroy the semaphore. More...
Operations
virtual void | Wait ()
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual PBoolean | Wait (const PTimeInterval &timeout)
| If the semaphore count is > 0, decrement the semaphore and return. More...
virtual void | Signal ()
| If there are waiting (blocked) threads then unblock the first one that was blocked. More...
Public Member Functions inherited from PSync
| PSync ()
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PQUEUE (ThreadQueue, PThread)

## Protected Attributes
unsigned | initialVar
unsigned | maxCountVar
ThreadQueue | waitQueue

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Friends inherited from PObject

## Detailed Description

This class defines a thread synchronisation object.

This is in the form of a integer semaphore. The semaphore has a count and a maximum value. The various combinations of count and usage of the Wait() and Signal() functions determine the type of synchronisation mechanism to be employed.

The Wait() operation is that if the semaphore count is > 0, decrement the semaphore and return. If it is = 0 then wait (block).

The Signal() operation is that if there are waiting threads then unblock the first one that was blocked. If no waiting threads and the count is less than the maximum then increment the semaphore.

The most common is to create a mutual exclusion zone. A mutex is where a piece of code or data cannot be accessed by more than one thread at a time. To prevent this the PSemaphore is used in the following manner:

          PSemaphore mutex(1, 1);  // Maximum value of 1 and initial value of 1.

          ...

          mutex.Wait();

          ... critical section - only one thread at a time here.

          mutex.Signal();

          ...

The first thread will pass through the Wait() function, a second thread will block on that function until the first calls the Signal() function, releasing the second thread.

## Constructor & Destructor Documentation

PSemaphore::PSemaphore | ( | unsigned | initial,
|  | unsigned | maximum
| ) |  |

Create a new semaphore with maximum count and initial value specified.

If the initial value is larger than the maximum value then is is set to the maximum value.

Parameters

  initial | Initial value for semaphore count.
  maximum | Maximum value for semaphore count.

PSemaphore::PSemaphore | ( | const PSemaphore & |  | ) |

Create a new semaphore with the same initial and maximum values as the original.

PSemaphore::~PSemaphore | ( |  | ) |

Destroy the semaphore.

This will assert if there are still waiting threads on the semaphore.

## Member Function Documentation

unsigned PSemaphore::GetInitial | ( |  | ) | const
| inline

unsigned PSemaphore::GetMaxCount | ( |  | ) | const
| inline

PSemaphore::PQUEUE | ( | ThreadQueue | ,
|  | PThread |
| ) |  |
| protected

virtual void PSemaphore::Signal | ( |  | ) |
| virtual

If there are waiting (blocked) threads then unblock the first one that was blocked.

If no waiting threads and the count is less than the maximum then increment the semaphore.

Implements PSync.

Referenced by PQueuedThreadPool< Work_T >::QueuedWorkerThread::AddWork(), and PQueuedThreadPool< Work_T >::QueuedWorkerThread::Shutdown().

virtual void PSemaphore::Wait | ( |  | ) |
| virtual

If the semaphore count is > 0, decrement the semaphore and return.

If if is = 0 then wait (block).

Implements PSync.

Referenced by PQueuedThreadPool< Work_T >::QueuedWorkerThread::Main().

virtual PBoolean PSemaphore::Wait | ( | const PTimeInterval & | timeout | ) |
| virtual

If the semaphore count is > 0, decrement the semaphore and return.

If if is = 0 then wait (block) for the specified amount of time.

Returns
  true if semaphore was signalled, false if timed out.

Implements PSync.

## Member Data Documentation

unsigned PSemaphore::initialVar
| protected

unsigned PSemaphore::maxCountVar
| protected

ThreadQueue PSemaphore::waitQueue
| protected

The documentation for this class was generated from the following files:

- semaphor.h